import axios from 'axios'

const API_URL = process.env.VUE_APP_URL

export function userDetail (jwt) {
    return axios.get(`${API_URL}profile/api/user`,  { headers: { Authorization: `Bearer: ${jwt}` , "Access-Control-Allow-Origin" : "*"} })
}
export function webDetail (jwt) {
    return axios.get(`${API_URL}webs/api/detail`,  { headers: { Authorization: `Bearer: ${jwt}` , "Access-Control-Allow-Origin" : "*"} })
}
export function authenticate (userData) {
    return axios.post(`${API_URL}login`, userData, { headers: { "Access-Control-Allow-Origin" : "*"} })
}
export function websitesList (jwt) {
    return axios.get(`${API_URL}webs/api/all`,  { headers: { Authorization: `Bearer: ${jwt}` , "Access-Control-Allow-Origin" : "*"} })
}
export function register (userData) {
    return axios.post(`${API_URL}register`, userData, { headers: { "Access-Control-Allow-Origin" : "*"} })
}

export function logout () {
    return axios.get(`${API_URL}logout`,{ headers: { "Access-Control-Allow-Origin" : "*"} } )
}
export function addWebsite(jwt, webData) {
    return axios.post(`${API_URL}webs/api/add`,webData,  { headers: { Authorization: `Bearer: ${jwt}` , "Access-Control-Allow-Origin" : "*"} })
}
