import 'bootstrap'
import Vue from 'vue'
import App from './App.vue'
import router from './router'
import BootstrapVue from 'bootstrap-vue/dist/bootstrap-vue.esm';
import 'bootstrap-vue/dist/bootstrap-vue.css';
import 'bootstrap/dist/css/bootstrap.css';
import store from "./store";
import Chartkick from 'vue-chartkick'
import Chart from 'chart.js'
import loader from "vue-ui-preloader";
import VueClipboard from 'vue-clipboard2'
import PulseLoader from 'vue-spinner/src/PulseLoader.vue'

Vue.use(BootstrapVue)
Vue.use(PulseLoader)
Vue.use(Chartkick.use(Chart))
Vue.use(loader)
Vue.use(VueClipboard)

Vue.config.productionTip = false

router.beforeEach((to, from, next) => {
  if (to.matched.some(record => record.meta.requiresAuth)) {
    // this route requires auth, check if logged in
    // if not, redirect to login page.
    if (!store.getters.isAuthenticated) {
      next({ name: 'login' })
    } else {
      next() // go to wherever I'm going
    }
  } else {
    next() // does not require auth, make sure to always call next()!
  }
})
new Vue({
  router,
  store,
  render: h => h(App),
  components: {
    PulseLoader
  }
}).$mount('#app')
