import uuid

from flask_sqlalchemy import SQLAlchemy
from sqlalchemy import ForeignKey

db = SQLAlchemy()

class Web(db.Model):
    id = db.Column(db.Integer, primary_key=True)
    name = db.Column(db.String(50), nullable=False)
    url = db.Column(db.String(50), nullable=False, unique=True)
    token = db.Column(db.String(), nullable=False, unique=True)
    verified = db.Column(db.Boolean, nullable=False)
    user_id = db.Column(db.Integer, ForeignKey('user.id'), nullable=False)
    keywords = db.Column(db.JSON)
    active_connection = db.Column(db.Boolean)

class User(db.Model):
    id = db.Column(db.Integer, primary_key=True)
    email = db.Column(db.String(50), nullable=False, unique=True)
    confirmed = db.Column(db.Boolean, nullable=False, default=False)
    password = db.Column(db.String(), nullable=False)
    first_name = db.Column(db.String(50), nullable=False)
    last_name = db.Column(db.String(50), nullable=False)

class Crawler_data(db.Model):
    id = db.Column('id', db.Text(length=36), default=lambda: str(uuid.uuid4()), primary_key=True)
    date = db.Column(db.DATE, nullable=False)
    data = db.Column(db.JSON, nullable=False)
    web_id = db.Column(db.Integer, ForeignKey('web.id'), nullable=False)
    type_id = db.Column(db.Integer, ForeignKey('crawler_type.id'), nullable=False)

class Crawler_type(db.Model):
    id = db.Column(db.Integer, primary_key=True)
    name = db.Column(db.String(50), nullable=False)