import re
import time
from deepmerge import always_merger
import requests
from urllib.parse import urlparse
import urllib3

urllib3.disable_warnings()

HOST = 'https://mysterious-cove-53924.herokuapp.com/selenium'
def validate(seed):
    source = requests.get(seed, verify=False).text
    soup = BeautifulSoup(source, 'html.parser')
    try:
        token = soup.find("meta", property="betkyanalyzertoken")
        token = token["content"]
    except:
        token = None
    return token


from bs4 import BeautifulSoup


def domain(seed):
    domain = urlparse(seed).netloc
    if seed.startswith('https'):
        return 'https://' + domain + '/'
    else:
        return 'http://' + domain + '/'


def analyze_link(link, seed):
    if link.endswith(('.jpg', '.jpeg', '.svg', '.png', '.pdf')):
        return 'none'
    elif link.startswith(('mailto:', 'tel:')):
        return 'none'
    elif ("www." in str(link) or 'http://' in str(link) or 'https://' in str(link)) and domain(seed) not in str(link):
        return 'outsider'
    elif domain(seed) in str(link):
        return 'full_url'
    else:
        return 'inner'


def keywords_crawler(seed, kw, token):
    if seed[-1] != '/':
        seed = seed + '/'
    print('seed', seed)
    frontier = [seed]
    crawled = []
    keywords = []
    ret_token = validate(seed)
    if ret_token != token:
        return 'not_verified'
    for k in kw:
        keywords.append(k.lower())
    data = {}
    outiders = []
    inner = []
    keywords_data = []
    for w in keywords:
        keywords_data.append({ w: {'text': 0, 'title': 0, 'desc': 0, 'img_name': 0, 'alt': 0}})

    start = time.time()
    while frontier:
        page = frontier.pop()
        if page not in crawled:
            crawled.append(page)
            try:
                source = requests.get(page, verify=False)
                source.encoding = source.apparent_encoding
                print(source.headers["content-type"])
                if "text/html" not in source.headers["content-type"]:
                    continue
                selenium_source = requests.post(HOST, json={'page': page})

                soup = BeautifulSoup(selenium_source.text, 'html.parser')

                links = soup.findAll('a', href=True)
                for link in links:
                    link_type = analyze_link(link['href'], seed)
                    if link_type == "outsider" and link['href'] not in outiders:
                        outiders.append(link['href'])
                    elif (link_type == "full_url" or link_type == "inner") \
                            and link['href'] not in inner:
                        inner.append(link['href'])
                    if link_type == 'full_url':
                        frontier.append(link['href'])
                    elif link_type == 'inner':
                        if link['href'] == '/':
                            continue
                        if link['href'] != '' and link['href'][0] == '/':
                            link['href'] = link['href'][1:]
                        frontier.append(domain(seed) + link['href'])
                    else:
                        continue

                try:
                    title = soup.title.text.lower()
                except:
                    title = None

                if title != None:
                    for k in keywords:
                        if k in title:
                            occures = title.count(k)
                            for w in keywords_data:
                                print(w.keys())
                                if k == list(w.keys())[0]:
                                    w[k]['title'] = w[k]['title'] + occures
                                    break
                            data = always_merger.merge(data, {k: {page: {'title': occures}}})

                # description
                try:
                    desc = soup.find("meta", attrs={'name': 'description'})
                    desc = desc['content'].lower()
                except:
                    desc = None
                if desc != None:
                    for k in keywords:
                        key_data = {}
                        if k in desc:
                            occures = desc.count(k)
                            for w in keywords_data:
                                if k == list(w.keys())[0]:
                                    w[k]['desc'] = w[k]['desc'] + occures
                                    break
                            data = always_merger.merge(data, {k: {page: {'desc': occures}}})

                #images
                images = soup.find_all('img')

                for k in keywords:
                    src_occures = 0
                    alt_occures = 0
                    for img in images:
                        try:
                            alt = img.get('alt', '')
                            if alt == '':
                                alt = img.get('data-alt', '')
                            src = img.get('src', '')
                            if src == '':
                                img.get('data-src', '')
                            src_name = src.split('/')[-1]
                            src_name = src_name.split('.')[0]
                            if src_name != None and k in src_name:
                                occures = src_name.count(k)
                                src_occures = src_occures + occures
                                for w in keywords_data:
                                    if k == list(w.keys())[0]:
                                        w[k]['img_name'] = w[k]['img_name'] + occures
                                        break
                            if alt != None and k in alt:
                                occures = alt.count(k)
                                alt_occures = alt_occures + occures
                                for w in keywords_data:
                                    if k == list(w.keys())[0]:
                                        w[k]['alt'] = w[k]['alt'] + occures
                                        break
                        except:
                            pass
                    if src_occures != 0:
                        data = always_merger.merge(data, {k: {page: {'img_name': src_occures}}})
                    if alt_occures != 0:
                        data = always_merger.merge(data, {k: {page: {'alt': alt_occures}}})
                #other
                tag = soup.body
                body_text = ''
                for string in tag.strings:
                    string = re.sub(' +', ' ', string)
                    body_text = body_text + string
                body_text = body_text.lower()

                if body_text != None:
                    for k in keywords:
                        if k in body_text:
                            occures = body_text.count(k)
                            for w in keywords_data:
                                if k == list(w.keys())[0]:
                                    w[k]['text'] = w[k]['text'] + occures
                                    break
                            data = always_merger.merge(data, {k: {page: {'text': occures}}})
                time.sleep(1)
                elapsed_time = (time.time() - start)
                if elapsed_time > 14400:
                    break
            except Exception as e:
                print('Failed to crawl ', page, '. Error: ', e)
                time.sleep(1)
    data = always_merger.merge(data, {'top': keywords_data})

    return data