from flask import Blueprint
from auth_utils import token_required
from models import Web, Crawler_data, Crawler_type


crawl = Blueprint('crawl', __name__, url_prefix='/crawl')


@crawl.route('/api/all/<web_id>', methods = ['GET'])
@token_required
def crawl_all(current_user, web_id):
    crawl_data = []
    crawl_list = Crawler_data.query.filter_by(web_id=web_id).all()
    for crawl in crawl_list:
        type = Crawler_type.query.filter_by(id=crawl.type_id).first()
        link = ''
        if crawl.type_id == 1:
            link = 'basic_detail'
        if crawl.type_id == 2:
            link = 'keywords_detail'
        if crawl.type_id == 3:
            link = 'centrality_detail'
        web = {'id': crawl.id, 'date': crawl.date, 'type': type.name, 'link': link}
        crawl_data.append(web)
    crawl_data.sort(key=lambda item:item['date'], reverse=True)
    data = {'crawls': crawl_data}

    return data

@crawl.route('/api/basic_crawl/detail/<crawl_id>', methods = ['GET'])
@token_required
def basiccrawl_detail(current_user, crawl_id):
    crawl = Crawler_data.query.filter_by(id=crawl_id).first()
    web = Web.query.filter_by(id=crawl.web_id).first()
    crawl_webs = []
    for item in crawl.data:
       if item != 'top':
           crawl_webs.append(item)
    data = {'date': crawl.date, 'data': crawl.data, 'web': web.name, 'crawl_webs': crawl_webs, 'web_id': web.id }

    return data, 200


@crawl.route('/api/keywords_crawl/detail/<crawl_id>', methods = ['GET'])
@token_required
def keywordscrawl_detail(current_user, crawl_id):
    crawl = Crawler_data.query.filter_by(id=crawl_id).first()
    web = Web.query.filter_by(id=crawl.web_id).first()
    crawl_words = []
    for item in crawl.data:
       if item != 'top':
           crawl_words.append(item)
    data = {'date': crawl.date, 'data': crawl.data, 'web': web.name, 'crawl_webs': crawl_words, 'web_id': web.id }

    return data, 200


@crawl.route('/api/centrality_crawl/detail/<crawl_id>', methods = ['GET'])
@token_required
def centralitycrawl_detail(current_user, crawl_id):
    crawl = Crawler_data.query.filter_by(id=crawl_id).first()
    web = Web.query.filter_by(id=crawl.web_id).first()
    data = {'date': crawl.date, 'data': crawl.data, 'web': web.name, 'web_id': web.id}

    return data, 200